#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"

enum ENUM_REASON_CODE{

   Position_Opened_in_Error            = 1,
   Adverse_Price_Movement              = 2,
   Close_of_Trading_Session_Near       = 3,
   See_Comment                         = 4,
   Hit_SL_or_TP                        = 5
   
};


enum ENUM_SENDDIAG{

   Send_Diag_Data                      =  1,
   Do_Not_Send_Diag_Data               =  2
   

};

enum ENUM_DIR_MODE{ // Not Yet Active

   Standard                          =  1,
   Reverse                           =  2

};

//Exern Variables//

extern int                 ContractSize                    =     100000;
input  string              ProductLicenceKey               =     "API9OfM2TTLgVExnVkV4blZrVjRibFpyVmpSaWJGcHlW";
input  ENUM_REASON_CODE    reasonCode                      =     5;
extern string              reasonComment                   =     "No Comment";
input  ENUM_SENDDIAG       SendDiagnosticData              =     1;

// Close Position Fraction

int    partialCloseLotsNum                     =     1;           /*This is expressed as the numerator fraction*/
int    partialCloseLotsDen                     =     2;           /*This is expressed as the denominator fraction i.e. 2 = 1/2, 4 = 1/4*/

//Spread Restriction

int    MaxSpread                               =     20;          /*A risk management parameter - this is the maximum, in points, we are prepared to pay to open a position*/     

//Broker Margin Level

int   brokerMarginLevel                        =      150;

// System & GMT Time

int    startingHour                            =     9;           /*GMT*/
int    endingHour                              =     17;          /*GMT*/

// Moving Average Data

int    AM_TrendFast                            =     1;           /*MODE_EMA*/
int    Period_TrendFast                        =     21;          /*Trend*/
int    AM_TrendSlow                            =     1;           /*MODE_EMA*/
int    Period_TrendSlow                        =     55;          /*Trend*/
int    AM_MomentumSlow                         =     0;           /*MODE_SMA*/
int    Period_MomentumSlow                     =     13;          /*Momentum*/
int    AM_MomentumFast                         =     1;           /*MODE_EMA*/
int    Period_MomentumFast                     =     8;           /*Momentum*/
int    Applied_Price                           =     0;           /*Applied Price*/        

// Candlestick Formation

double hammerHeadPct                           =     0.20;        // 0.2
double hammerHandlePct                         =     0.20;        // 0.2
double retracePercentage                       =     0.40;        // 0.5
int    candleBodyLength                        =     10;          // OBSOLETE IN CURRENT VERSION. PLEASE DISREGARD

//PercentageRisk

bool              NewBar;
bool              ClosePosition;
bool              manualClose;
bool              BuyMod;
bool              SellMod;
bool              InitOrders;
bool              InitTime;
bool              secondaryStopLoss;
bool              excessPositions;
bool              partialOrderClose;
datetime          lastStamp;
datetime          DateTimeNow;
datetime          BarTime;
datetime          DateTimeVariable = D'1970.01.01 00:00:00';
color             buycolor;
color             sellcolor;
int               hourOfDay;
int               TradeDuration;
int               maPeriod;
int               fastMAPeriod;
int               ordersTotal;
int               thisAccountNumber;
int               lastError;
int               breakeven;
int               stopLossPoints;
int               marginBuffer;
int               GMTAdjustment;
int               i_Hours;
int               openingTime;
int               closingTime;
double            numberLotsToClose;
double            messagePromptEstLoss;
double            pipDisplayLong ;
double            pipDisplayShort ;
double            pctRisk;  
double            pctRiskConversion;
double            stopLoss;                      
double            takeProfit;                    
double            shortStopLoss;                 
double            shortTakeProfit;               
double            longStopLoss;                  
double            longTakeProfit;                
double            basisPointsToRisk;     
double            riskPercentageDisplay;          
double            broker_ratio                  = 0;        // Broker Ratio
double            broker_lot_min                = 0;        // Broker Minimum permitted amount of a lot.
double            broker_lot_max                = 0;        // Broker Maximum permitted amount of a lot.
double            broker_lot_step               = 0;        // Broker Step for changing lots.
double            broker_contract               = 0;        // Broker Lot size in the base currency.
double            broker_stop_level             = 0;        // Broker Stop level in points
double            broker_freeze_level           = 0;        // Order freeze level in points. If the execution price lies within the range defined by the freeze level, the order cannot be modified, cancelled or closed.
double            broker_point                  = 0;        // Broker Point size in the quote currency.
double            marginRequired;
double            freeMargin;
double            RewardFactor;
double            trendFast;
double            trendSlow;
double            momentumFast;
double            momentumSlow;
double            momentumFastCurrent;
double            momentumFastPrevious;
double            pips;
double            LotSize;
double            tickvalue;
double            spread;
double            positionSwap;
double            currentOpenPrice;
double            positionCommission;
double            positionProfit;
double            currentBid;
double            currentAsk;
double            currentSpread;
double            entryPriceBid;
double            entryPriceAsk;
double            accountBalance;
double            amountAtRisk;
double            totalSpread;
double            totalCommission;
double            positionMarginReq;
double            totalCommissionSqrd;
double            volumePurchased;
double            profitCalc;
double            lossCalc;
double            exchangeRateFactor;
double            currencyConversion;
double            tradeSpread;
double            bullRetracementCandleClose;
double            bullRetracementCandleOpen;
double            initialTrendBearCandleOpen;
double            initialTrendBearCandleClose;
double            OpeningPrice;
double            Ticket;
double            StopLoss;
double            bullHammerHead;
double            bullHammerHandle;
double            bearHammerHandle;
double            bullHammerHandleInv;
double            bearHammerHandleInv;
double            bearHammerHead;
double            bearRetracementCandle;
double            bullRetracementCandle;
double            initialTrendBullCandle;
double            initialTrendBearCandle;
double            hammerHeadOpen;
double            hammerHeadClose;
double            remainingMargin;
double            partial;
string            symbol;
string            eaName;
string            accountCurrency;
string            error;

enum ENUM_FUNCTION_MODE { MODE_DEINIT = -1, MODE_INIT, MODE_WORK };
struct STRUCT_ORDER_INFO
  {
   int               ticket;
   int               magic;
   int               type;
   double            lot;
   double            open;
   double            close;
   double            sl;
   double            tp;
   double            profit;
   datetime          time;
  };

STRUCT_ORDER_INFO stcOrdOldArr[1], stcOrdNewArr[1];   //arrays containing order list with information
string sOrdOldArr[], sOrdNewArr[];

